From 06183a751fe4c363a04f3e35b38ddb11f78c13b2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 20 2020 08:27:45 +0000
Subject: [PATCH 1746/2232] Merge pull request 586 from dtolnay/c_str


Add c_str() member function for rust::String

---

diff --git a/include/cxx.h b/include/cxx.h
index f41dde7..fc63095 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -53,6 +53,8 @@ public:
   std::size_t size() const noexcept;
   std::size_t length() const noexcept;
 
+  const char *c_str() noexcept;
+
   using iterator = char *;
   iterator begin() noexcept;
   iterator end() noexcept;
diff --git a/src/cxx.cc b/src/cxx.cc
index 776663e..6863129 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -42,6 +42,7 @@ bool cxxbridge1$string$from(rust::String *self, const char *ptr,
 void cxxbridge1$string$drop(rust::String *self) noexcept;
 const char *cxxbridge1$string$ptr(const rust::String *self) noexcept;
 std::size_t cxxbridge1$string$len(const rust::String *self) noexcept;
+void cxxbridge1$string$reserve_total(rust::String *self, size_t cap) noexcept;
 
 // rust::Str
 bool cxxbridge1$str$valid(const char *ptr, std::size_t len) noexcept;
@@ -127,6 +128,14 @@ std::size_t String::length() const noexcept {
   return cxxbridge1$string$len(this);
 }
 
+const char *String::c_str() noexcept {
+  auto len = this->length();
+  cxxbridge1$string$reserve_total(this, len + 1);
+  auto ptr = this->data();
+  const_cast<char *>(ptr)[len] = '\0';
+  return ptr;
+}
+
 String::iterator String::begin() noexcept {
   return const_cast<char *>(this->data());
 }
diff --git a/src/symbols/rust_string.rs b/src/symbols/rust_string.rs
index 944aec4..91fd78a 100644
--- a/src/symbols/rust_string.rs
+++ b/src/symbols/rust_string.rs
@@ -45,3 +45,8 @@ unsafe extern "C" fn string_ptr(this: &String) -> *const u8 {
 unsafe extern "C" fn string_len(this: &String) -> usize {
     this.len()
 }
+
+#[export_name = "cxxbridge1$string$reserve_total"]
+unsafe extern "C" fn string_reserve_total(this: &mut String, cap: usize) {
+    this.reserve(cap);
+}
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index eeca98a..ca2bb6a 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -716,6 +716,12 @@ extern "C" const char *cxx_run_test() noexcept {
     ASSERT((second.*cmp)(sec) == second_sec);
   }
 
+  rust::String cstring = "test";
+  ASSERT(cstring.length() == 4);
+  ASSERT(strncmp(cstring.data(), "test", 4) == 0);
+  ASSERT(strncmp(cstring.c_str(), "test", 5) == 0);
+  ASSERT(cstring.length() == 4);
+
   cxx_test_suite_set_correct();
   return nullptr;
 }

